searchData={"content_type":"text/markdown","items":[{"doc":"Wrapper around Plug and Bandit to create APIs","ref":"Francis.html","title":"Francis","type":"module"},{"doc":"","ref":"Francis.html#delete/2","title":"Francis.delete/2","type":"macro"},{"doc":"","ref":"Francis.html#get/2","title":"Francis.get/2","type":"macro"},{"doc":"","ref":"Francis.html#patch/2","title":"Francis.patch/2","type":"macro"},{"doc":"","ref":"Francis.html#post/2","title":"Francis.post/2","type":"macro"},{"doc":"","ref":"Francis.html#put/2","title":"Francis.put/2","type":"macro"},{"doc":"","ref":"Francis.html#unmatched/1","title":"Francis.unmatched/1","type":"macro"},{"doc":"","ref":"Francis.html#ws/2","title":"Francis.ws/2","type":"macro"},{"doc":"","ref":"Francis.Plug.Router.html","title":"Francis.Plug.Router","type":"module"},{"doc":"# Francis\n\n> Nothing is stable! Try it out with caution\n\nSimple boilerplate killer using Plug and Bandit inspired by [Sinatra](https://sinatrarb.com) for Ruby","ref":"readme.html","title":"Francis","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `francis` to your list of dependencies in `mix.exs`:\n\n```elixir\n\ndef deps do\n  [\n    {:francis, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Francis","type":"extras"},{"doc":"```elixir\ndefmodule Example do\n  use Francis\n\n  get(\"/\", fn _ -> \" world \" end)\n  get(\"/:name\", fn %{params: %{\"name\" => name}} -> \"hello #{name}\" end)\n\n  ws(\"ws\", fn \"ping\" -> \"pong\" end)\n\n  unmatched(fn _ -> \"not found\" end)\nend\n```","ref":"readme.html#example","title":"Example - Francis","type":"extras"},{"doc":"With the `plugs` option you are able to apply a list of plugs that happen between before dispatching the request.\n\n```elixir\n# Example with Basic authentication enabled\ndefmodule Example do\n  import Plug.BasicAuth\n\n  use Francis, plugs: [{:basic_auth, username: \"test\", password: \"test\"}]\n\n  get(\"/\", fn _ -> \" world \" end)\n  get(\"/:name\", fn %{params: %{\"name\" => name}} -> \"hello #{name}\" end)\n\n  ws(\"ws\", fn \"ping\" -> \"pong\" end)\n\n  unmatched(fn _ -> \"not found\" end)\nend\n```","ref":"readme.html#example-with-plugs","title":"Example with Plugs - Francis","type":"extras"},{"doc":"```elixir\n  # create a new file called server.ex\n  Mix.install([:francis])\n\n  defmodule Example do\n    use Francis\n\n    get(\"/\", fn _ -> \" world \" end)\n    get(\"/:name\", fn %{params: %{\"name\" => name}} -> \"hello #{name}\" end)\n\n    ws(\"ws\", fn \"ping\" -> \"pong\" end)\n\n    unmatched(fn _ -> \"not found\" end)\n\n    def start(_, _) do\n      children = [{Bandit, [plug: __MODULE__]}]\n      Supervisor.start_link(children, strategy: :one_for_one)\n    end\n  end\n\n  Example.start(nil, nil)\n  Process.sleep(:infinity)\n  # run this file with elixir server.ex\n```\n\nCheck the folder [example](https://github.com/filipecabaco/francis/tree/main/example) to check the code.","ref":"readme.html#example-using-it-with-mix-install","title":"Example using it with Mix.install - Francis","type":"extras"}]}